Index: branches/1.3/gui/scripts/flowvisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4848)
@@ -63,69 +63,65 @@
     public method get {args}
     public method isconnected {}
-    public method limits { cname }
-    public method overMarker { m x }
+    public method limits { tf }
+    public method overmarker { m x }
     public method parameters {title args} { 
         # do nothing 
     }
-    public method removeDuplicateMarker { m x }
+    public method rmdupmarker { m x }
     public method scale {args}
-    public method updateTransferFunctions {}
+    public method updatetransferfuncs {}
+
+    protected method Connect {}
+    protected method CurrentVolumeIds {{what -all}}
+    protected method Disconnect {}
+    protected method Resize {}
+    protected method ResizeLegend {}
+    protected method AdjustSetting {what {value ""}}
+    protected method InitSettings { args }
+    protected method Pan {option x y}
+    protected method Rebuild {}
+    protected method ReceiveData { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { tf vmin vmax size }
+    protected method Rotate {option x y}
+    protected method SendDataObjs {}
+    protected method SendTransferFuncs {}
+    protected method Slice {option args}
+    protected method SlicerTip {axis}
+    protected method Zoom {option}
 
     # soon to be removed.
-    private method Flow {option args}
-    private method Play {}
-    private method Pause {}
+    protected method Flow {option args}
+    protected method Play {}
+    protected method Pause {}
+
 
     # The following methods are only used by this class.
-    private method AdjustSetting {what {value ""}}
+
     private method AddIsoMarker { x y }
     private method BuildCameraTab {}
     private method BuildCutplanesTab {}
     private method BuildViewTab {}
-    private method BuildVolumeComponents {}
     private method BuildVolumeTab {}
     private method ComputeTransferFunc { tf }
-    private method Connect {}
-    private method CurrentVolumeIds {{what -all}}
-    private method Disconnect {}
     private method EventuallyResize { w h } 
     private method EventuallyGoto { nSteps } 
     private method EventuallyResizeLegend { } 
     private method FlowCmd { dataobj comp nbytes extents }
-    private method GetDatasetsWithComponent { cname } 
-    private method GetFlowInfo { widget }
     private method GetMovie { widget width height }
     private method GetPngImage { widget width height }
-    private method InitSettings { args }
     private method NameTransferFunc { dataobj comp }
-    private method Pan {option x y}
     private method PanCamera {}
     private method ParseLevelsOption { tf levels }
     private method ParseMarkersOption { tf markers }
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveData { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { tf vmin vmax size }
-    private method Resize {}
-    private method ResizeLegend {}
-    private method Rotate {option x y}
-    private method SendTransferFuncs {}
+    private method WaitIcon { option widget }
+    private method str2millisecs { value } 
+    private method millisecs2str { value } 
+    private method GetFlowInfo { widget }
+    private method particles { tag name } 
+    private method box { tag name } 
+    private method streams { tag name } 
+    private method arrows { tag name } 
     private method SetOrientation { side }
-    private method Slice {option args}
-    private method SlicerTip {axis}
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method WaitIcon { option widget }
-    private method Zoom {option}
-    private method arrows { tag name } 
-    private method box { tag name } 
-    private method millisecs2str { value } 
-    private method particles { tag name } 
-    private method str2millisecs { value } 
-    private method streams { tag name } 
 
     private variable _arcball ""
@@ -135,4 +131,5 @@
     private variable _serverObjs   ;# maps dataobj-component to volume ID 
                                     # in the server
+    private variable _sendobjs ""  ;# list of data objs to send to server
     private variable _recvObjs  ;# list of data objs to send to server
     private variable _obj2style    ;# maps dataobj-component to transfunc
@@ -149,6 +146,4 @@
     private variable _activeTf ""  ;# The currently active transfer function.
     private variable _first ""     ;# This is the topmost volume.
-    private variable _volcomponents   ; # Array of components found 
-    private variable _componentsList   ; # Array of components found 
     private variable _nextToken 0
     private variable _icon 0
@@ -183,4 +178,9 @@
     $_dispatcher dispatch $this !legend "[itcl::code $this ResizeLegend]; list"
 
+    # Send dataobjs event
+    $_dispatcher register !send_dataobjs
+    $_dispatcher dispatch $this !send_dataobjs \
+        "[itcl::code $this SendDataObjs]; list"
+
     # Send transferfunctions event
     $_dispatcher register !send_transfunc
@@ -220,26 +220,28 @@
     # Initialize the view to some default parameters.
     array set _view {
-        -qw      0.853553
-        -qx      -0.353553
-        -qy      0.353553
-        -qz      0.146447
-        -xpan    0
-        -ypan    0
-        -zoom    1.0
+        qw      0.853553
+        qx      -0.353553
+        qy      0.353553
+        qz      0.146447
+        zoom    1.0
+        xpan    0
+        ypan    0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
-
-    set _limits(v) [list 0.0 1.0]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
+
+    set _limits(vmin) 0.0
+    set _limits(vmax) 1.0
     set _reset 1
 
     array set _settings [subst {
-        $this-qw                $_view(-qw)
-        $this-qx                $_view(-qx)
-        $this-qy                $_view(-qy)
-        $this-qz                $_view(-qz)
-        $this-zoom              $_view(-zoom)    
-        $this-xpan              $_view(-xpan)
-        $this-ypan              $_view(-ypan)
+        $this-qw                $_view(qw)
+        $this-qx                $_view(qx)
+        $this-qy                $_view(qy)
+        $this-qz                $_view(qz)
+        $this-zoom              $_view(zoom)    
+        $this-xpan              $_view(xpan)
+        $this-ypan              $_view(ypan)
         $this-arrows            0
         $this-currenttime       0
@@ -251,8 +253,4 @@
         $this-streams           0
         $this-volume            1
-        $this-light             40
-        $this-light2side        1
-        $this-opacity           50
-        $this-thickness         350
         $this-xcutplane         0
         $this-xcutposition      0
@@ -337,5 +335,6 @@
     set _image(legend) [image create photo]
     itk_component add legend {
-        canvas $itk_component(plotarea).legend -height 50 -highlightthickness 0
+        canvas $itk_component(plotarea).legend \
+            -height 50 -highlightthickness 0 -background black
     } {
         usual
@@ -561,5 +560,7 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FlowvisViewer::destructor {} {
+    set _sendobjs ""  ;# stop any send in progress
     $_dispatcher cancel !rebuild
+    $_dispatcher cancel !send_dataobjs
     $_dispatcher cancel !send_transfunc
     image delete $_image(plot)
@@ -671,5 +672,5 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FlowvisViewer::delete {args} {
-    flow stop
+     flow stop
     if {[llength $args] == 0} {
         set args $_dlist
@@ -721,48 +722,27 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FlowvisViewer::scale {args} {
-    array set styles {
-        -color BCGYR
-        -levels 6
-        -markers ""
-        -opacity 0.5
-    }
-    array unset _limits 
-    array unset _volcomponents 
-    foreach dataobj $args {
-        if { ![$dataobj isvalid] } {
-            continue;                     # Object doesn't contain valid data.
-        }
-        foreach cname [$dataobj components] {
-            if { ![info exists _volcomponents($cname)] } {
-                lappend _componentsList $cname
-                array set styles [lindex [$dataobj components -style $cname] 0]
-                set cmap [ColorsToColormap $styles(-color)]
-                set _cname2defaultcolormap($cname) $cmap
-                set _settings($cname-colormap) $styles(-color)
-            }
-            lappend _volcomponents($cname) $dataobj-$cname
-            array unset limits
-            array set limits [$dataobj valueLimits $cname]
-            set _limits($cname) $limits(v)
-        }
-        foreach axis {x y z v} {
-            foreach { min max } [$dataobj limits $axis] break
+    foreach val {xmin xmax ymin ymax vmin vmax} {
+        set _limits($val) ""
+    }
+    foreach obj $args {
+        foreach axis {x y v} {
+
+            foreach { min max } [$obj limits $axis] break
+
             if {"" != $min && "" != $max} {
-                if { ![info exists _limits($axis)] } {
-                    set _limits($axis) [list $min $max]
+                if {"" == $_limits(${axis}min)} {
+                    set _limits(${axis}min) $min
+                    set _limits(${axis}max) $max
                 } else {
-                    foreach {amin amax} $_limits($axis) break
-                    if {$min < $amin} {
-                        set amin $min
+                    if {$min < $_limits(${axis}min)} {
+                        set _limits(${axis}min) $min
                     }
-                    if {$max > $amax} {
-                        set amax $max
+                    if {$max > $_limits(${axis}max)} {
+                        set _limits(${axis}max) $max
                     }
-                    set _limits($axis) [list $amin $amax]
                 }
             }
         }
     }
-    #BuildVolumeComponents
 }
 
@@ -877,5 +857,5 @@
         if { $_reportClientInfo }  {
             # Tell the server the viewer, hub, user and session.
-            # Do this immediately on connect before buffering any commands
+            # Do this immediately on connect before buffing any commands
             global env
 
@@ -934,4 +914,89 @@
     # disconnected -- no more data sitting on server
     array unset _serverObjs
+    set _sendobjs ""
+}
+
+# ----------------------------------------------------------------------
+# USAGE: SendDataObjs
+#
+# Used internally to send a series of volume objects off to the
+# server.  Sends each object, a little at a time, with updates in
+# between so the interface doesn't lock up.
+# ----------------------------------------------------------------------
+itcl::body Rappture::FlowvisViewer::SendDataObjs {} {
+    blt::busy hold $itk_component(hull)
+    foreach dataobj $_sendobjs {
+        foreach comp [$dataobj components] {
+            # Send the data as one huge base64-encoded mess -- yuck!
+            set data [$dataobj blob $comp]
+            set nbytes [string length $data]
+            set extents [$dataobj extents $comp]
+
+            # I have a field. Is a vector field or a volume field?
+            if { $extents == 1 } {
+                set cmd "volume data follows $nbytes $dataobj-$comp\n"
+            } else {
+                set cmd [FlowCmd $dataobj $comp $nbytes $extents]
+                if { $cmd == "" } {
+                    puts stderr "no command"
+                    continue
+                }
+            }
+            f { ![SendBytes $cmd] } {
+                puts stderr "can't send"
+                return
+            }
+            if { ![SendBytes $data] } {
+                puts stderr "can't send"
+                return
+            }
+            NameTransferFunc $dataobj $comp
+            set _recvObjs($dataobj-$comp) 1
+        }
+    }
+    set _sendobjs ""
+    blt::busy release $itk_component(hull)
+
+    # Turn on buffering of commands to the server.  We don't want to
+    # be preempted by a server disconnect/reconnect (which automatically
+    # generates a new call to Rebuild).   
+    StartBufferingCommands
+
+    # activate the proper volume
+    set _first [lindex [get] 0]
+    if { "" != $_first } {
+        set axis [$_first hints updir]
+        if {"" != $axis} {
+            SendCmd "up $axis"
+        }
+
+        if 0 {
+        set location [$_first hints camera]
+        if { $location != "" } {
+            array set _view $location
+        }
+        set _settings($this-qw)    $_view(qw)
+        set _settings($this-qx)    $_view(qx)
+        set _settings($this-qy)    $_view(qy)
+        set _settings($this-qz)    $_view(qz)
+        set _settings($this-xpan)  $_view(xpan)
+        set _settings($this-ypan)  $_view(ypan)
+        set _settings($this-zoom)  $_view(zoom)
+        set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+        $_arcball quaternion $q
+        SendCmd "camera orient $q"
+        SendCmd "camera reset"
+        PanCamera
+        SendCmd "camera zoom $_view(zoom)"
+        }
+        # The active transfer function is by default the first component of
+        # the first data object.  This assumes that the data is always
+        # successfully transferred.
+        set comp [lindex [$_first components] 0]
+        set _activeTf [lindex $_obj2style($_first-$comp) 0]
+    }
+
+    SendCmd "flow reset"
+    StopBufferingCommands
 }
 
@@ -950,8 +1015,10 @@
     }
 
-    # Ensure that the global thickness setting (in the slider settings widget)
-    # is used for the active transfer-function. Update the values in the
-    # _settings varible.
-
+    # Ensure that the global opacity and thickness settings (in the slider
+    # settings widgets) are used for the active transfer-function.  Update the
+    # values in the _settings varible.
+    set value $_settings($this-opacity)
+    set opacity [expr { double($value) * 0.01 }]
+    set _settings($this-$tf-opacity) $opacity
     set value $_settings($this-thickness)
     # Scale values between 0.00001 and 0.01000
@@ -1030,22 +1097,28 @@
     set h [winfo height $c]
     set lx 10
+    # FIXME:  I don't know what I have to do this for the 2D flow
+    #         example.  Otherwise the canvas background is white.
+    #         I'll get to this when we add background changes into
+    #         nanvis.
+    $c configure -background black
     set ly [expr {$h - 1}]
-    if {"" == [$c find withtag colorbar]} {
+    if {"" == [$c find withtag transfunc]} {
         $c create image 10 10 -anchor nw \
-            -image $_image(legend) -tags colorbar
+            -image $_image(legend) -tags transfunc
         $c create text $lx $ly -anchor sw \
             -fill $itk_option(-plotforeground) -tags "limits vmin"
         $c create text [expr {$w-$lx}] $ly -anchor se \
             -fill $itk_option(-plotforeground) -tags "limits vmax"
-        $c lower colorbar
-        $c bind colorbar <ButtonRelease-1> [itcl::code $this AddIsoMarker %x %y]
+        $c lower transfunc
+        $c bind transfunc <ButtonRelease-1> \
+            [itcl::code $this AddIsoMarker %x %y]
     }
     # Display the markers used by the active transfer function.
     set tf $_obj2style($tag)
-    foreach {vmin vmax} [limits $tf] break
-    $c itemconfigure vmin -text [format %g $vmin]
+    array set limits [limits $tf]
+    $c itemconfigure vmin -text [format %.2g $limits(vmin)]
     $c coords vmin $lx $ly
 
-    $c itemconfigure vmax -text [format %g $vmax]
+    $c itemconfigure vmax -text [format %.2g $limits(vmax)]
     $c coords vmax [expr {$w-$lx}] $ly
 
@@ -1087,8 +1160,9 @@
     set dataobj [lindex $parts 0]
     set _serverObjs($tag) 0
-    set _limits($tag) [list $values(min) $values(max)]
+    set _limits($tag-min)  $values(min);  # Minimum value of the volume.
+    set _limits($tag-max)  $values(max);  # Maximum value of the volume.
     unset _recvObjs($tag)
     if { [array size _recvObjs] == 0 } {
-        updateTransferFunctions
+        updatetransferfuncs
     }
 }
@@ -1134,14 +1208,6 @@
         foreach comp [$dataobj components] {
             set tag $dataobj-$comp
-            set isvtk 0
-            # FIXME: Would like to use the type method of the dataobj
-            # but the returned value isn't well defined now
-            if {[catch {
-                # Send the data as one huge base64-encoded mess -- yuck!
-                set data [$dataobj blob $comp]
-            }]} {
-                set data [$dataobj vtkdata $comp]
-                set isvtk 1
-            }
+            # Send the data as one huge base64-encoded mess -- yuck!
+            set data [$dataobj blob $comp]
             set nbytes [string length $data]
             if { $_reportClientInfo }  {
@@ -1159,6 +1225,6 @@
             set extents [$dataobj extents $comp]
             # I have a field. Is a vector field or a volume field?
-            if { !$isvtk && $extents == 1 } {
-                SendCmd "volume data follows $nbytes $tag"
+            if { $extents == 1 } {
+                set cmd "volume data follows $nbytes $tag\n"
             } else {
                 set cmd [FlowCmd $dataobj $comp $nbytes $extents]
@@ -1167,6 +1233,6 @@
                     continue
                 }
-                append _outbuf $cmd
-            }
+            }
+            append _outbuf $cmd
             append _outbuf $data
             NameTransferFunc $dataobj $comp
@@ -1178,8 +1244,10 @@
 
     # Reset the camera and other view parameters
-    InitSettings light2side light opacity isosurface grid axes volume outline
-
+    InitSettings light2side light transp isosurface grid axes volume outline
+    
     # nothing to send -- activate the proper volume
     if {"" != $_first} {
+        AdjustSetting light
+        AdjustSetting transp
         set axis [$_first hints updir]
         if {"" != $axis} {
@@ -1192,18 +1260,18 @@
 
     }
-    set _settings($this-qw)    $_view(-qw)
-    set _settings($this-qx)    $_view(-qx)
-    set _settings($this-qy)    $_view(-qy)
-    set _settings($this-qz)    $_view(-qz)
-    set _settings($this-xpan)  $_view(-xpan)
-    set _settings($this-ypan)  $_view(-ypan)
-    set _settings($this-zoom)  $_view(-zoom)
-
-    set q [ViewToQuaternion]
+    set _settings($this-qw)    $_view(qw)
+    set _settings($this-qx)    $_view(qx)
+    set _settings($this-qy)    $_view(qy)
+    set _settings($this-qz)    $_view(qz)
+    set _settings($this-xpan)  $_view(xpan)
+    set _settings($this-ypan)  $_view(ypan)
+    set _settings($this-zoom)  $_view(zoom)
+
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
     $_arcball quaternion $q
     SendCmd "camera orient $q"
     SendCmd "camera reset"
     PanCamera
-    SendCmd "camera zoom $_view(-zoom)"
+    SendCmd "camera zoom $_view(zoom)"
 
     foreach dataobj [get] {
@@ -1261,10 +1329,10 @@
     foreach key [array names _serverObjs *-*] {
         if {[string match $_first-* $key]} {
-            array set styles {
+            array set style {
                 -cutplanes 1
             }
             foreach {dataobj comp} [split $key -] break
-            array set styles [lindex [$dataobj components -style $comp] 0]
-            if {$what != "-cutplanes" || $styles(-cutplanes)} {
+            array set style [lindex [$dataobj components -style $comp] 0]
+            if {$what != "-cutplanes" || $style(-cutplanes)} {
                 lappend rlist $_serverObjs($key)
             }
@@ -1285,22 +1353,22 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            set _settings($this-zoom) $_view(-zoom)
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            set _settings($this-zoom) $_view(zoom)
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            set _settings($this-zoom) $_view(-zoom)
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            set _settings($this-zoom) $_view(zoom)
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -qw      0.853553
-                -qx      -0.353553
-                -qy      0.353553
-                -qz      0.146447
-                -zoom    1.0
-                -xpan    0
-                -ypan    0
+                qw      0.853553
+                qx      -0.353553
+                qy      0.353553
+                qz      0.146447
+                zoom    1.0
+                xpan   0
+                ypan   0
             }
             if { $_first != "" } {
@@ -1310,15 +1378,15 @@
                 }
             }
-            set q [ViewToQuaternion]
+            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
             $_arcball quaternion $q
             SendCmd "camera orient $q"
             SendCmd "camera reset"
-            set _settings($this-qw)    $_view(-qw)
-            set _settings($this-qx)    $_view(-qx)
-            set _settings($this-qy)    $_view(-qy)
-            set _settings($this-qz)    $_view(-qz)
-            set _settings($this-xpan)  $_view(-xpan)
-            set _settings($this-ypan)  $_view(-ypan)
-            set _settings($this-zoom)  $_view(-zoom)
+            set _settings($this-qw)    $_view(qw)
+            set _settings($this-qx)    $_view(qx)
+            set _settings($this-qy)    $_view(qy)
+            set _settings($this-qz)    $_view(qz)
+            set _settings($this-xpan)  $_view(xpan)
+            set _settings($this-ypan)  $_view(ypan)
+            set _settings($this-zoom)  $_view(zoom)
         }
     }
@@ -1326,6 +1394,8 @@
 
 itcl::body Rappture::FlowvisViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    #set x [expr ($_view(xpan)) / $_limits(xrange)]
+    #set y [expr ($_view(ypan)) / $_limits(yrange)]
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
@@ -1365,9 +1435,9 @@
 
                 set q [$_arcball rotate $x $y $_click(x) $_click(y)]
-                QuaternionToView $q
-                set _settings($this-qw) $_view(-qw)
-                set _settings($this-qx) $_view(-qx)
-                set _settings($this-qy) $_view(-qy)
-                set _settings($this-qz) $_view(-qz)
+                foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
+                set _settings($this-qw) $_view(qw)
+                set _settings($this-qx) $_view(qx)
+                set _settings($this-qy) $_view(qy)
+                set _settings($this-qz) $_view(qz)
                 SendCmd "camera orient $q"
 
@@ -1402,9 +1472,9 @@
         set x [expr $x / double($w)]
         set y [expr $y / double($h)]
-        set _view(-xpan) [expr $_view(-xpan) + $x]
-        set _view(-ypan) [expr $_view(-ypan) + $y]
+        set _view(xpan) [expr $_view(xpan) + $x]
+        set _view(ypan) [expr $_view(ypan) + $y]
         PanCamera
-        set _settings($this-xpan) $_view(-xpan)
-        set _settings($this-ypan) $_view(-ypan)
+        set _settings($this-xpan) $_view(xpan)
+        set _settings($this-ypan) $_view(ypan)
         return
     }
@@ -1419,9 +1489,9 @@
         set _click(x) $x
         set _click(y) $y
-        set _view(-xpan) [expr $_view(-xpan) - $dx]
-        set _view(-ypan) [expr $_view(-ypan) - $dy]
+        set _view(xpan) [expr $_view(xpan) - $dx]
+        set _view(ypan) [expr $_view(ypan) - $dy]
         PanCamera
-        set _settings($this-xpan) $_view(-xpan)
-        set _settings($this-ypan) $_view(-ypan)
+        set _settings($this-xpan) $_view(xpan)
+        set _settings($this-ypan) $_view(ypan)
     }
     if { $option == "release" } {
@@ -1576,12 +1646,21 @@
             }
         }
-        opacity {
+        transp {
             if { $_first != "" } {
                 set comp [lindex [$_first components] 0]
                 set tag $_first-$comp
+                set opacity [expr { 0.01 * double($_settings($this-transp)) }]
+                SendCmd "$tag configure -opacity $opacity"
+            }
+        }
+        opacity {
+            if { $_first != "" && $_activeTf != "" } {
                 set opacity [expr { 0.01 * double($_settings($this-opacity)) }]
-                SendCmd "$tag configure -opacity $opacity"
-            }
-        }
+                set tf $_activeTf
+                set _settings($this-$tf-opacity) $opacity
+                updatetransferfuncs
+            }
+        }
+
         thickness {
             if { $_first != "" && $_activeTf != "" } {
@@ -1591,5 +1670,5 @@
                 set tf $_activeTf
                 set _settings($this-$tf-thickness) $sval
-                updateTransferFunctions
+                updatetransferfuncs
             }
         }
@@ -1699,15 +1778,20 @@
 #              now.
 #
-itcl::body Rappture::FlowvisViewer::NameTransferFunc { dataobj cname } {
-    array set styles {
+itcl::body Rappture::FlowvisViewer::NameTransferFunc { dataobj comp } {
+    array set style {
         -color BCGYR
         -levels 6
-        -opacity 0.5
-    }
-    array set styles [lindex [$dataobj components -style $cname] 0]
-    set _settings($this-opacity) [expr $styles(-opacity) * 100]
-    set _obj2style($dataobj-$cname) $cname
-    lappend _style2objs($cname) $dataobj $cname
-    return $cname
+        -opacity 1.0
+        -light 40
+        -transp 50
+    }
+    array set style [lindex [$dataobj components -style $comp] 0]
+    set _settings($this-light) $style(-light)
+    set _settings($this-transp) $style(-transp)
+    set _settings($this-opacity) [expr $style(-opacity) * 100]
+    set tf "$style(-color):$style(-levels):$style(-opacity)"
+    set _obj2style($dataobj-$comp) $tf
+    lappend _style2objs($tf) $dataobj $comp
+    return $tf
 }
 
@@ -1722,8 +1806,10 @@
 #
 itcl::body Rappture::FlowvisViewer::ComputeTransferFunc { tf } {
-    array set styles {
+    array set style {
         -color BCGYR
         -levels 6
-        -opacity 0.5
+        -opacity 1.0
+        -light 40
+        -transp 50
     }
     set dataobj ""; set comp ""
@@ -1732,5 +1818,6 @@
         return 0
     }
-    array set styles [lindex [$dataobj components -style $comp] 0]
+    array set style [lindex [$dataobj components -style $comp] 0]
+
 
     # We have to parse the style attributes for a volume using this
@@ -1749,28 +1836,24 @@
     if { ![info exists _isomarkers($tf)] } {
         # Have to defer creation of isomarkers until we have data limits
-        if { [info exists styles(-markers)] &&
-             [llength $styles(-markers)] > 0  } {
-            ParseMarkersOption $tf $styles(-markers)
+        if { [info exists style(-markers)] &&
+             [llength $style(-markers)] > 0  } {
+            ParseMarkersOption $tf $style(-markers)
         } else {
-            ParseLevelsOption $tf $styles(-levels)
-        }
-    }
-    if { [info exists styles(-nonuniformcolors)] } {
-        foreach { value color } $styles(-nonuniformcolors) {
+            ParseLevelsOption $tf $style(-levels)
+        }
+    }
+    if { [info exists style(-nonuniformcolors)] } {
+        foreach { value color } $style(-nonuniformcolors) {
             append cmap "$value [Color2RGB $color] "
         }
     } else {
-        set cmap [ColorsToColormap $styles(-color)]
-    }
-
-    if { ![info exists _settings($this-opacity)] } {
-        set _settings($this-opacity) [expr $styles(-opacity) * 100]
-    }
-
-    # Transfer function should be normalized with [0,1] range
-    # The volume shading opacity setting is used to scale opacity
-    # in the volume shader.
-    set max 1.0
-
+        set cmap [ColorsToColormap $style(-color)]
+    }
+    set tag $this-$tf
+    if { ![info exists _settings($tag-opacity)] } {
+        set _settings($tag-opacity) $style(-opacity)
+    }
+    set max 1.0 ;#$_settings($tag-opacity)
+    
     set isovalues {}
     foreach m $_isomarkers($tf) {
@@ -1780,5 +1863,4 @@
     set isovalues [lsort -real $isovalues]
 
-    set tag $this-$tf
     if { ![info exists _settings($tag-thickness)]} {
         set _settings($tag-thickness) 0.005
@@ -1835,8 +1917,7 @@
 itcl::configbody Rappture::FlowvisViewer::plotbackground {
     if { [isconnected] } {
-        set color $itk_option(-plotbackground)
-        set rgb [Color2RGB $color]
-        SendCmd "screen bgcolor $rgb"
-        $itk_component(legend) configure -background $color
+        foreach {r g b} [Color2RGB $itk_option(-plotbackground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
     }
 }
@@ -1847,11 +1928,7 @@
 itcl::configbody Rappture::FlowvisViewer::plotforeground {
     if { [isconnected] } {
-        set color $itk_option(-plotforeground)
-        set rgb [Color2RGB $color]
-        SendCmd "volume outline color $rgb"
-        SendCmd "grid axiscolor $rgb"
-        SendCmd "grid linecolor $rgb"
-        $itk_component(legend) itemconfigure labels -fill $color
-        $itk_component(legend) itemconfigure limits -fill $color
+        foreach {r g b} [Color2RGB $itk_option(-plotforeground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
     }
 }
@@ -1887,5 +1964,4 @@
             set x [expr {double($i)/($levels+1)}]
             set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
             $m relval $x
             lappend _isomarkers($tf) $m 
@@ -1894,5 +1970,4 @@
         foreach x $levels {
             set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
             $m relval $x
             lappend _isomarkers($tf) $m 
@@ -1922,5 +1997,4 @@
             set value [expr {$value * 0.01}]
             set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
             $m relval $value
             lappend _isomarkers($tf) $m
@@ -1928,5 +2002,4 @@
             # ${n} : Set absolute value.
             set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
             $m absval $value
             lappend _isomarkers($tf) $m
@@ -1938,5 +2011,5 @@
 # USAGE: UndateTransferFuncs 
 # ----------------------------------------------------------------------
-itcl::body Rappture::FlowvisViewer::updateTransferFunctions {} {
+itcl::body Rappture::FlowvisViewer::updatetransferfuncs {} {
     $_dispatcher event -after 100 !send_transfunc
 }
@@ -1949,13 +2022,12 @@
     set c $itk_component(legend)
     set m [Rappture::IsoMarker \#auto $c $this $tf]
-    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
     set w [winfo width $c]
     $m relval [expr {double($x-10)/($w-20)}]
     lappend _isomarkers($tf) $m
-    updateTransferFunctions
+    updatetransferfuncs
     return 1
 }
 
-itcl::body Rappture::FlowvisViewer::removeDuplicateMarker { marker x } {
+itcl::body Rappture::FlowvisViewer::rmdupmarker { marker x } {
     set tf [$marker transferfunc]
     set bool 0
